package common;

import java.io.File;
import java.util.SortedMap;
import java.util.TreeMap;

public class DiskStream extends FileStream {
	public static final int NO_INDEX=-1;
	private long length;
	private File playListFile;
	private SortedMap<Long, String> chapters=new TreeMap<Long, String>();
	private int index=NO_INDEX;
	
	public DiskStream(File[] files, long length, File playListFile, SortedMap<Long, String> chapters, int index) {
		this(files, length, playListFile, chapters);
		this.index=index;
	}
	public DiskStream(File[] files, long length, File playListFile, SortedMap<Long, String> chapters) {
		super(null, files);
		this.length=length;
		this.playListFile=playListFile;
		this.chapters=chapters;
	}

	public DiskStream(Job job, String fileNames) {
		super(job, FileStream.getFiles(fileNames));
		// TODO Auto-generated constructor stub
	}
	public SortedMap getChapters() {
		return chapters;
	}
	public long getLength() {
		return length;
	}

	public void setLength(long length) {
		this.length = length;
	}
	public String getVolumeLabel() {
		return Util.getVolumeLabel(files[0]);
	}
	public String toString() {
		StringBuffer sb=new StringBuffer(getVolumeLabel());
		sb.append(" - ");
		sb.append(Util.timeToString(length));
		sb.append(" - ");
		sb.append(chapters.size());
		sb.append(" Chapters - ");
		sb.append(playListFile.getName());
		if (index != NO_INDEX) {
			sb.append('[');
			sb.append(index + 1);
			sb.append(']');
		}
		return sb.toString();
	}

}
