package io;

import java.io.File;

public class NameTypeFileFilter extends javax.swing.filechooser.FileFilter {

	private String fileTypes[];
	private String description;
	
	public NameTypeFileFilter(String fileTypes[], String description) {
		this.fileTypes=fileTypes;
		StringBuffer sb=new StringBuffer(description);
		sb.append(" (");
		String sep="";
		for (int i=0;i<fileTypes.length;i++) {
			sb.append(sep);
			sep=", ";
			sb.append('*');
			sb.append(fileTypes[i]);
		}
		sb.append(')');
		this.description=sb.toString();
	}
	public NameTypeFileFilter(String fileType, String description) {
		this (new String[]{fileType}, description);
	}
    public boolean accept(File file) {
        if (file.isDirectory()) {
        	return true;
        }
        String fileLower=file.getName().toLowerCase();
        for (int i=0;i<fileTypes.length;i++) {
        	if (fileLower.endsWith(fileTypes[i])) {
        		return true;
        	}
        }
        return false;
    }
    public String getDescription() {
        return description;
    }
    public String[] getFileTypes() {
    	return fileTypes;
    }
}
