package ui;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Font;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;

import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import common.ExternalProcess;
import common.InputStreamBuffer;

public class ProcessDialog extends JDialog {
	private JTextArea textArea;
	private JLabel processLabel;
	private Process process;
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		ProcessDialog pd=new ProcessDialog();
			
		try {
			//pd.exec(new String[]{"cmd","/c", "dir"}, null, null);
			//pd.exec(new String[]{/*"cmd","/c",*/ "C:/tools/Muxer/./eac3to/eac3to.exe", "C:/RemuxTool/HDDVD_b1.thd", "C:/RemuxTool/HDDVD.ac3"}, null, null);
			//pd.exec(new String[]{/*"cmd","/c",*/ "C:\\tools\\Muxer\\.\\tsMuxeR\\tsMuxeR.exe", "C:/RemuxTool/HDDVD.meta", "K:\\Video\\Departed.ts"}, null, null);
			pd.exec(new String[]{/*"cmd","/c",*/ "C:\\RemuxTool\\h264info\\h264info.exe", "-r", "-iK:\\Video\\Beowulf.avc","-oC:\\Temp\\Beowulf.avc"}, null, null);
			//pd.exec(new String[]{"cmd","/c", "pause"}, null, null);
			System.out.println(pd.getProcessLog());
			pd.dispose();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	private class LogHandler {

	}
	
	public ProcessDialog() {
		super();
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		setSize(800,200);

		setTitle("External Process");
		Container panel=this.getContentPane();
		panel.setLayout(new BorderLayout());
		processLabel=new JLabel("Process");
		panel.add(processLabel, BorderLayout.NORTH);
		JScrollPane scrollPane=new JScrollPane(textArea=new JTextArea());
		textArea.setFont(new Font(Font.MONOSPACED, Font.PLAIN,12));
		panel.add(scrollPane, BorderLayout.CENTER);
		
		WindowAdapter windowAdapter=new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				if (process != null) {
					process.destroy();
					textArea.append("\nProcess aborted by user.");
				}
			}
		};
		this.addWindowListener(windowAdapter);
	}

	public int exec(String command[], String envp[], File dir) throws IOException {
		this.setVisible(true);
		process=Runtime.getRuntime().exec(command, envp, dir);
		String commandString=ExternalProcess.unsplit(command);
		processLabel.setText(commandString);
		textArea.setText(commandString+'\n');
		InputStreamBuffer logHandler=new InputStreamBuffer();
		int exitValue=Integer.MIN_VALUE;
		while (exitValue==Integer.MIN_VALUE) {
			try {
				exitValue=process.exitValue();
			} catch (IllegalThreadStateException e) {
			}
			ArrayList <String> newList=logHandler.logStream(process.getInputStream());
			if (!newList.isEmpty()) {
				logHandler.commit(newList);
				textArea.setText(logHandler.toString());
			}
			newList=logHandler.logStream(process.getErrorStream());
			if (!newList.isEmpty()) {
				logHandler.commit(newList);
				textArea.setText(logHandler.toString());
			}
			try {
				Thread.sleep(100);
				//System.out.println("Sleeping");
			} catch (InterruptedException e) {
			}
		}
		process=null;
		return exitValue; 
	}
	public String getProcessLog() {
		return textArea.getText();
	}
}
