package ui.tonmt;

import io.NameTypeFileFilter;

import javax.swing.JFileChooser;

import ui.ToUI;

import common.DiskFinder;
import common.bluray.PlayListAnalyzer;

import demux.pes.XplHelper;

public class ToNmtUI extends ToUI {
	private static final String NAME="To NMT 6.0.6";
	
	protected ToNMTPrefs getPrefs() {
		return ToNMTPrefs.getPrefs();
	}
	
	protected ToNmtPreferenceDialog getPreferenceDialog() {
		return new ToNmtPreferenceDialog();
	}
	
	public static void main(String args[]) {
		ToNmtUI frame = new ToNmtUI();
		frame.setVisible(true);
	}
	
	protected ToNmtUI() {
		super(NAME);
		inputFileChooser=new JFileChooser();
		inputFileChooser.addChoosableFileFilter(new NameTypeFileFilter(new String[]{".evo"}, "HD DVD Stream"));
		inputFileChooser.addChoosableFileFilter(new NameTypeFileFilter(new String[]{XplHelper.HD_HDVD_PLAYLIST_EXT}, "HD DVD Playlists"));
		inputFileChooser.addChoosableFileFilter(new NameTypeFileFilter(new String[]{".m2ts",".mts"}, "BluRay/AVCHD Stream"));
		inputFileChooser.addChoosableFileFilter(new NameTypeFileFilter(new String[]{PlayListAnalyzer.BLURAY_PLAYLIST_EXT}, "BluRay Playlists"));
		inputFileChooser.setAcceptAllFileFilterUsed(false);
		inputFileChooser.setMultiSelectionEnabled(true);

		saveAsFileChooser=new JFileChooser();
		saveAsFileChooser.addChoosableFileFilter(new NameTypeFileFilter(new String[]{".m2ts",".mts"}, "BluRay Stream"));
		saveAsFileChooser.addChoosableFileFilter(new NameTypeFileFilter(new String[]{".ts"}, "Transport Stream"));
		saveAsFileChooser.setAcceptAllFileFilterUsed(false);
		saveAsFileChooser.setMultiSelectionEnabled(false);
		saveAsFileChooser.setDialogType(JFileChooser.SAVE_DIALOG);
		
		diskFinder=new DiskFinder(true, true);
	}
}
